using System;
using System.Collections.Generic;
using System.Linq;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Audio;
using Microsoft.Xna.Framework.Content;
using Microsoft.Xna.Framework.GamerServices;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Input;
using Microsoft.Xna.Framework.Media;
using Microsoft.Xna.Framework.Net;
using Microsoft.Xna.Framework.Storage;

using MasaoXNALibrary;
using System.Diagnostics;

namespace MasaoXNA1
{
    /// <summary>
    /// This is the main type for your game
    /// </summary>
    public class Game1 : Microsoft.Xna.Framework.Game
    {
        GraphicsDeviceManager graphics;
        SpriteBatch spriteBatch;

        //  ^Cgo[̕
        string title_str = "Masao XNA Windows";

        //  XvCgtHg
        SpriteFont sprite_font_score;        //  XRA̕p
        SpriteFont sprite_font_message;      //  bZ[Wp

        //  L[{[h̏
        KeyboardState keybord_state;

        //  摜
        Texture2D pattern_img;
        Texture2D mapchip_img;
        Texture2D title_img;
        Texture2D ending_img;
        Texture2D gameover_img;
        Texture2D haikei_img;

        //  TEh
        AudioEngine audio_engine;
        SoundBank sound_bank;
        WaveBank wave_bank;

        //  j
        MasaoXNA masao;
        
        
        public Game1()
        {
            graphics = new GraphicsDeviceManager(this);
            Content.RootDirectory = "Content";

            //  ^Cgo[̕ݒ
            Window.Title = title_str;

            //  𑜓xݒ
            graphics.PreferredBackBufferWidth = 640;
            graphics.PreferredBackBufferHeight = 480;
        }

        /// <summary>
        /// Allows the game to perform any initialization it needs to before starting to run.
        /// This is where it can query for any required services and load any non-graphic
        /// related content.  Calling base.Initialize will enumerate through any components
        /// and initialize them as well.
        /// </summary>
        protected override void Initialize()
        {
            // TODO: Add your initialization logic here

            base.Initialize();
        }

        /// <summary>
        /// LoadContent will be called once per game and is the place to load
        /// all of your content.
        /// </summary>
        protected override void LoadContent()
        {
            // Create a new SpriteBatch, which can be used to draw textures.
            spriteBatch = new SpriteBatch(GraphicsDevice);

            // TODO: use this.Content to load your game content here

            string st1;
            

            //  XvCgtHgǂݍ
            sprite_font_score = Content.Load<SpriteFont>("sf_score");
            sprite_font_message = Content.Load<SpriteFont>("sf_message");

            //  摜ǂݍ
            pattern_img = Content.Load<Texture2D>("pattern");
            mapchip_img = Content.Load<Texture2D>("mapchip");
            title_img = Content.Load<Texture2D>("title");
            ending_img = Content.Load<Texture2D>("ending");
            gameover_img = Content.Load<Texture2D>("gameover");
            haikei_img = Content.Load<Texture2D>("haikei");

            //  TEh쐬
            audio_engine = new AudioEngine("Content\\MasaoXACT.xgs");
            sound_bank = new SoundBank(audio_engine, "Content\\Sound Bank.xsb");
            wave_bank = new WaveBank(audio_engine, "Content\\Wave Bank.xwb");


            //  j  쐬
            masao = new MasaoXNA();

            //  j  OtBbNo^
            masao.SetGame(this);
            masao.SetSpriteBatch(spriteBatch);
            masao.SetSpriteFont(sprite_font_score, sprite_font_message);
            masao.SetSystemImage(pattern_img, mapchip_img, title_img, ending_img, gameover_img
                                    , haikei_img, haikei_img, haikei_img, haikei_img);

            //  j  TEho^
            masao.SetAudioEngine(audio_engine, sound_bank, wave_bank);

            //  j  N̏
            masao.InitLoad();

            //  }bvpgslkZbg
            st1 = Content.Load<string>("game1");
            //st1 = Content.Load<string>("game2");      //  ̃}bv
            masao.SetHTMLText(st1);
            
            //  w`bsɂaflĐ
            //masao.SetBGMSwitch(true);                 //  aflL
            //masao.SetBGMLoop(true);                   //  afl[vĐ

            //  l鑀
            //masao.SetMyRunType(1);                    //  {^fQ񉟂
            masao.SetMyRunType(2);                      //  a{^Ȃ{^
        }

        /// <summary>
        /// UnloadContent will be called once per game and is the place to unload
        /// all content.
        /// </summary>
        protected override void UnloadContent()
        {
            // TODO: Unload any non ContentManager content here
        }

        /// <summary>
        /// Allows the game to run logic such as updating the world,
        /// checking for collisions, gathering input, and playing audio.
        /// </summary>
        /// <param name="gameTime">Provides a snapshot of timing values.</param>
        protected override void Update(GameTime gameTime)
        {
            // Allows the game to exit
            if (GamePad.GetState(PlayerIndex.One).Buttons.Back == ButtonState.Pressed)
                this.Exit();

            // TODO: Add your update logic here

            //  L[{[h̏Ԃ擾
            keybord_state = Keyboard.GetState();

            //  j̃CvOĂяo
            masao.Update();

            //  Esc L[I
            if (keybord_state.IsKeyDown(Keys.Escape))
            {
                this.Exit();
            }

            //  AudioEngine ̍XV
            audio_engine.Update();
            

            base.Update(gameTime);
        }

        /// <summary>
        /// This is called when the game should draw itself.
        /// </summary>
        /// <param name="gameTime">Provides a snapshot of timing values.</param>
        protected override void Draw(GameTime gameTime)
        {
            GraphicsDevice.Clear(Color.CornflowerBlue);

            // TODO: Add your drawing code here

            //  j̕`vOĂяo
            masao.Draw();

            
            base.Draw(gameTime);
        }
    }
}
